Subject: bug#42289: recursive import does not dort alphabetically

From: Leo Famulari <[email-masked]>
Date: Thu, 9 Jul 2020 13:39:55 -0400

On Thu, Jul 09, 2020 at 01:26:03PM +0200, Hartmut Goebel wrote:
> Most file I've been working on ask for sorting alphabetically. (And IMHO
> this is a good recommendation to follow.)

What are the benefits of sorting packages?

The ordering of packages is not usually important to the machine, and
humans can search for the package names.

I think that sorting the packages is not necessarily desired, especially
for modules where a lot of packages may be imported (e.g. Rust). It
makes the Git diffs harder to understand and work with when merging or
rebasing, compared to just adding the new packages at the end of the
file.

In cases where packages are inherited to create multiple package
versions, alphanumerical sorting breaks the inheritance [0], although
inheritance is problematic in its own right and we should probably stop
using it.

[0] See <https://lists.gnu.org/archive/html/guix-devel/2020-04/msg00040.html>